/* << High C V1.4  &  386ASM V2.0 >> ******************************************
**
**	SND ̧قĐ܂B
**
**	1991.01.29 : CREATE
**	1991.01.29 : FINISH
**
**	< HISTORY >
**	1991.01.29 : CREATE
**
**	< note > : TABS = 4
**
**	Programed by Y.Hirata ( Nifty ID : NAB03321 )
**
******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <snd.h>
#include <egb.h>
#include <mos.h>
#include <dos.h>
#include <msdos.cf>
#include "egbwork.h"							/*  TownsMENUp				*/

#define		TRUE			1
#define		FALSE			0

extern		INT23_init() ;
extern		INT23_end() ;

typedef unsigned char	uchar ;
typedef unsigned short	ushort ;
typedef unsigned long	ulong ;
typedef unsigned int	uint ;

enum Values_for_ColorNo {
		C_BLACK, C_BLUE, C_RED, C_PURPLE,				/*  0 -  3	*/
		C_GREEN, C_LIGHTBLUE, C_YELLOW, C_WHITE,		/*  4 -  7	*/
		C_HBLACK, C_HBLUE, C_HRED, C_HPURPLE,			/*  8 - 11	*/
		C_HGREEN, C_HLIGHTBLUE, C_HYELLOW, C_HWHITE		/* 12 - 15	*/
	} ;

enum Values_for_Write_Mode {
		PSET, PRESET, OR, AND, XOR, NOT, MATTE, PASTEL,		/*  0 ` 7	*/
		DUMMY_1, OPAQUE, IMPSET, INPNOT, MASKSET, MASKRESET, MASKNOT
															/*  8 ` 15	*/
	} ;

#define	SworkSize	16384						/*  ޗpƈ滲		*/
char	Swork[SworkSize];						/*  ޗpƈ			*/

char	Para[128] ;								/*  EGBp					*/

#define	MworkSize	4096						/*  ϳƈ̻			*/
char	Mwork[MworkSize] ;						/*  ϳƈ				*/

char	Sndfile[128] ;							/*  PCM ̧			*/

int		Sndsize ;								/*  PCM ް		*/
char	*Snddata ;								/*  PCM i[̈		*/
char	Sndflg = FALSE ;						/*  PCM  READ ׸		*/

struct _SND_DATA {
	char	name[8] ;							/*  Ȱ				*/
	ulong	sid ;								/*  ID					*/
	ulong	len ;								/*  ް					*/
	ulong	loop_p ;							/*  ٰ߲				*/
	ulong	loop_len ;							/*  ٰݸ޽				*/
	ushort	sf ;								/*  ݸގg			*/
	short	hosei ;								/*  ̕␳(߯)	*/
	uchar	onkai ;								/*  ̉K				*/
	uchar	flg ;								/*  ?׸					*/
	} ;

union _SND_CHECK {
	struct _SND_DATA	data ;
	char				buf[30] ;
	} Snd ;

typedef struct {
	char	_reserved[21] ;						/*  reserved area			*/
	char	_attrib ;							/*  attribute byte			*/
	ushort	_ftime ; 							/*  time of file			*/
	ushort	_fdate ;							/*  date of file			*/
	ulong	_fsize ;							/*  file size				*/
	char	d_name[13] ;						/*  packed file name		*/
} DIR ;

/*************************  cs`̐ݒ  ************************************/
void setdta( p )
DIR *p ;
{
	Registers.AX.LH.H = 0x1a ;
	Registers.DX.R = (uint)p ;
	Registers.DS.R = getds() ;
	calldos() ;
}

/*******************  ŏɈvt@Č  ************************/
int firstsearch( path,attr,dta )
char	*path ;
int		attr ;
DIR		*dta ;
{
	setdta( dta ) ;
	Registers.AX.LH.H = 0x4e ;
	Registers.CX.R = attr ;						/*  t@C̎	*/
	Registers.DX.R = (uint)path ;				/*  t@C		*/
	Registers.DS.R = getds() ;
	calldos();
	if ( (Registers.Flags & 0x0001) != 0 )
		return ( FALSE ) ;
	else
		return ( TRUE ) ;					/*  Ȃ ^ return	*/
}

/***************************  t@CTCY擾  ****************************/
int getfsize()
{
	DIR		dta ;
	ushort	attr=0 ;

	if ( firstsearch( Sndfile,attr,&dta ) ) {		/*  ŏ̃Gg	*/
		Sndsize = dta._fsize ;
		return( dta._fsize ) ;
	} else {									/*  t@CȂ	*/
		return( -1 ) ;
	}
}

/****************************  ݒ  *********************************/
void textatr( int t_sp,int f_st )
{
	EGB_textDirection( Gwork,0 ) ;
	EGB_textDisplayDirection( Gwork,0 ) ;
	EGB_textSpace( Gwork,t_sp ) ;		/* ԃXy[X [dot]		*/
	EGB_textZoom( Gwork,0,8,16 ) ;		/* ANK  :  8 x 16			*/
	EGB_textZoom( Gwork,1,16,16 ) ;		/*  : 16 x 16			*/
	EGB_fontStyle( Gwork,f_st ) ;		/* W					*/
}

/******************************  o  ***********************************/
void puttext( x, y, text, col )
int	x, y, col ;
char	*text ;
{
	uint	sl ;

	EGB_color( Gwork,0,col ) ;			/* OiF					*/
	WORD( Para+0 ) = x ;				/* X Point					*/
	WORD( Para+2 ) = y ;				/* Y Point					*/
	sl = strlen( text ) ;
	WORD( Para+4 ) = sl ;
	strcpy( Para+6,text ) ; 
	EGB_sjisString( Gwork,Para ) ;		/* \					*/
}

/***************************  SND DATA ̓Ǎ  *****************************/
void snd_load()
{
	FILE *fp;

	Sndflg = FALSE ;
	if ( getfsize() == -1 ) return ;
	
	Snddata = malloc( Sndsize ) ;				/*  SND f[^i[̈m	*/
	if ( Snddata == NULL ) {
		printf("<snd_load> malloc error!\n") ;
		return ;
	} else {
		fp = fopen( Sndfile,"rb" ) ;
		fread( Snddata,1,Sndsize,fp ) ;
		fclose( fp ) ;
		Sndflg = TRUE ;
	}

	memcpy( Snd.buf,Snddata,30 ) ;

	if ( !Sndflg ) {
		printf("\x1b[33m") ;
		printf(".SND ̧ ( %s ) ǂݍ߂܂łB\x1b[m\n",Sndfile) ;
		return ;
	} else {
		printf("f[^ \x1b[36m%s \x1b[m",Sndfile) ;
		printf(" Đ܂B\n") ;
	}
	printf("\n") ;

/*
**	PCM ݒ肷
*/
	SND_pcm_mode_set( 1 ) ;						/*  PCMӰِݒ	*/
	SND_volume_change( 71,127 ) ;				/*  őحтɂ		*/

}

/***************************  }EX  **********************************/
void minit()
{
	MOS_start( Mwork,MworkSize ) ;
	MOS_disp( FALSE ) ;								/* }EX\		*/
}

/*******************************  ݒ  **********************************/
void init()
{
	SND_init( Swork ) ;								/*  ޏ			*/

	snd_load() ;

	SND_elevol_mute( 0x0001 ) ;						/*  PCM ̂Эĉ*/
	SND_elevol_all_mute( -1 ) ;						/*  SЭẲ		*/

/*
**	TownsMENÚAPage 1 & 0  Page 1 O, MENU Page 0 ɏĂB
**	V1.1 L20 _
*/
	EGB_displayPage( Gwork,1,3 ) ;	/* Show page 0 & 1 : Priority 1		*/

	minit() ;										/*  ϳ			*/

	EGB_writePage( Gwork,1 ) ;						/* Write to Page 1		*/
	EGB_writeMode( Gwork,OPAQUE ) ;					/* wiFœhׂ	*/
	EGB_color( Gwork,0,C_BLACK ) ;					/* OiF : Black		*/
	EGB_color( Gwork,1,C_HWHITE ) ;					/* wiF : H_White		*/
	EGB_color( Gwork,2,C_HGREEN ) ;					/* ʓhF : H_Green		*/
	EGB_color( Gwork,3,C_BLACK ) ;					/* ߐF : Black		*/
	EGB_displayStart( Gwork,0,0,0 ) ;				/* \Jnʒu			*/
	EGB_displayStart( Gwork,1,0,0 ) ;				/* zʈʒu 		*/
	EGB_displayStart( Gwork,2,1,1 ) ;				/* ʂ̊g			*/
	EGB_displayStart( Gwork,3,639,479 ) ;			/* ʂ̑傫 		*/
	textatr( 0,0 ) ;

}

/********************************  ڲJn  *********************************/
void play_start()
{
	char	buf[128] ;
	int		mbot, mx, my ;
	int		c ;

	do {											/*  ϳ̊J҂		*/
		MOS_rdpos( &mbot,&mx,&my ) ;
	} while ( mbot ) ;

	strcpy( buf,"@@@@@@@@@@@@@@@@@@@" ) ;
	c = ( 80 - strlen( buf ) ) / 2 + 1 ;
	puttext( c*8,11*16+1,buf,C_HBLACK ) ;
	sprintf( buf,"< %s >",Sndfile ) ;
	c = ( 80 - strlen( buf ) ) / 2 + 1 ;
	puttext( c*8,11*16+1,buf,C_HBLACK ) ;
	sprintf( buf,"Đ܂ (NOTE=%d)",Snd.data.onkai ) ;
	c = ( 80 - strlen( buf ) ) / 2 + 1 ;
	puttext( c*8,12*16+9,buf,C_HBLACK ) ;

	SND_pcm_play_stop( 71 ) ;
	SND_pcm_play( 71,Snd.data.onkai,127,Snddata ) ;

	while ( TRUE ) {
		if ( !SND_pcm_status( 71 ) ) break ;
		MOS_rdpos( &mbot,&mx,&my ) ;
		if ( mbot ) break ;
	}

	SND_pcm_play_stop( 71 ) ;
}

/*********************************  C  **********************************/
void main( int ac, char *av[] )
{
	int		endp ;

	printf("SNDPLAY.EXP  v0.50  (c) ߵߵ 1991.        ") ;
	printf("<< Copyright (C) Y.Hirata 1991. >>\n") ;

	if ( ac > 1 ) {									/*  			*/
		strcpy( Sndfile,av[1] ) ;
		endp = strlen( Sndfile ) ;
		if ( strchr( Sndfile,'.' ) == NULL ) {		/*  ̧يgqȂ		*/
			strcat( Sndfile,".SND" ) ;
		} else {
			if ( strcmp( Sndfile+endp-4,".SND" ) &&
					strcmp( Sndfile+endp-4,".snd" ) ) {
				printf("\x1b[31mERROR\x1b[m : FILE NAME ( %s ) - ",Sndfile) ;
				printf(".SND ̧ wł܂I\n") ;
				exit( 1 ) ;
			}
		}
	} else {										/*  Ȃ			*/
		printf(".SND ̧قw肵ĉB\n") ;
		exit( 1 ) ;
	}

	INT23_init() ;									/*  ^C Ͻݒ			*/
	init() ;										/*  e평ݒ		*/
	if ( Sndflg )
		play_start() ;								/*  ڲJn			*/

close:
	if ( Sndflg ) {
		free( Snddata ) ;
	}
	SND_end() ;										/*  ޏI			*/
	INT23_end() ;									/*  ^C Ͻ			*/

	printf("\n۸тI܂B\n") ;

}

